/* An HTTP GET handler - CONFIG */
esp_err_t config_get_handler(httpd_req_t *req)
{   
    ESP_LOGI(TAG, "Config");
    generate_response(CONFIG_MODE);
    /* Send response with custom headers and body set as the
     * string passed in user context*/
    const char* resp_str = (const char*) user_str;
    //const char* resp_str = (const char*) req->user_ctx;
    httpd_resp_send(req, resp_str, strlen(resp_str));

    return ESP_OK;
}

esp_err_t cfgsav_get_handler(httpd_req_t *req)
{
    char*  buf;
    char param1[34],param2[66],param3[34],param4[34],param5[18],param6[18],param7[18], param8[4],param9[66], param10[4],temp[18],t1[34],t2[66],t3[34],t4[34],t5[18],t6[18],t7[18],t9[66];
    int isip_t5=0,isip_t6=0,isip_t7=0, isip_t11=0,use_dhcp_temp=0,use_auth_temp=0,need_reboot=0;
    size_t buf_len;    
    buf_len = httpd_req_get_url_query_len(req) + 1;
    cfg_err = 0;
    if (buf_len > 1) 
        {
        buf = malloc(buf_len);
        if (httpd_req_get_url_query_str(req, buf, buf_len) == ESP_OK) 
            {
            if (httpd_query_key_value(buf, "SSID", param1, sizeof(param1)) == ESP_OK) 
                {
                strcpy(t1,url_decode(param1));
                ESP_LOGI(TAG, "Found URL query parameter => SSID=%s", t1);
                }
            if (httpd_query_key_value(buf, "password", param2, sizeof(param2)) == ESP_OK) 
                {
                strcpy(t2,url_decode(param2));
                ESP_LOGI(TAG, "Found URL query parameter => password");
                }
            if (httpd_query_key_value(buf, "station", param3, sizeof(param3)) == ESP_OK) 
                {
                strcpy(t3,url_decode(param3));
                ESP_LOGI(TAG, "Found URL query parameter => name=%s", t3);
                }
            if (httpd_query_key_value(buf, "station_password", param4, sizeof(param4)) == ESP_OK) 
                {
                strcpy(t4,url_decode(param4));
                ESP_LOGI(TAG, "Found URL query parameter => station password");
                }
            if (httpd_query_key_value(buf, "ip", param5, sizeof(param5)) == ESP_OK) 
                {
                strcpy(t5,url_decode(param5));
                strcpy(temp,t5);
                isip_t5 = isIp_v4(temp);
                ESP_LOGI(TAG, "Found URL query parameter => station ip=%s", t5);
                }
            if (httpd_query_key_value(buf, "gw", param6, sizeof(param6)) == ESP_OK) 
                {
                strcpy(t6,url_decode(param6));
                strcpy(temp,t6);
                isip_t6 = isIp_v4(temp);
                ESP_LOGI(TAG, "Found URL query parameter => station gateway=%s", t6);
                }
            if (httpd_query_key_value(buf, "netmask", param7, sizeof(param7)) == ESP_OK) 
                {
                strcpy(t7,url_decode(param7));
                strcpy(temp,t7);
                isip_t7 = isIp_v4(temp);
                ESP_LOGI(TAG, "Found URL query parameter => station netmask=%s", t7);
                }
            if (httpd_query_key_value(buf, "use_dhcp", param8, sizeof(param8)) == ESP_OK) 
                {
                ESP_LOGI(TAG, "Found URL query parameter => use_dhcp=%s",param8);
                if (strcmp(url_decode(param8),"yes") == 0)
                    use_dhcp_temp = 1;
                }
             if (httpd_query_key_value(buf, "station_new_password_1", param9, sizeof(param9)) == ESP_OK) 
                {
                ESP_LOGI(TAG, "Found URL query parameter => station_new_password_1");
                strcpy(t9,url_decode(param9));
                }  
             if (httpd_query_key_value(buf, "use_password", param10, sizeof(param10)) == ESP_OK) 
                {
                ESP_LOGI(TAG, "Found URL query parameter => use_password=%s", param10);
                if (strcmp(url_decode(param10),"yes") == 0)
                    use_auth_temp = 1;
                }
            if ( (strlen(t1) > 1 && strlen(t1) <= 32) && strlen(t2) <= 64 && (strlen(t3) > 1 && strlen(t3) <= 32) && (use_dhcp_temp || (isip_t5 && isip_t6 && isip_t7)) && (strlen(t9) > 1 && strlen(t9) <= 64)  && strcmp (t4, config.station_password) == 0)
                {
                /*update time */
                time(&now);
                localtime_r(&now, &timeinfo);
                strftime(strftime_buf, sizeof(strftime_buf), "%c", &timeinfo);
                strcat(strftime_buf," UTC / config!");
                //Wlan ID
                if (strcmp(config.ssid,t1) != 0)
                    {
                    need_reboot = 1;
                    strcpy(config.ssid,t1);
                    }
                //Wlan Password
                if (strcmp (t2, "current password") != 0)
                    {
                    need_reboot = 1;
                    strcpy(config.password,t2);
                    }
                //IP Data
                if (use_dhcp_temp)
                    {
                    if (strcmp(config.use_dhcp,"no") == 0)
                        need_reboot = 1;
                    strcpy(config.use_dhcp,"yes");
                    strcpy(config.ip,"");  
                    strcpy(config.gw,""); 
                    strcpy(config.netmask,"");
                    }
                else
                    {
                    if (strcmp(config.use_dhcp,"yes") == 0)
                        need_reboot = 1;
                    strcpy(config.use_dhcp,"no");
                    if (strcmp(config.ip,t5) != 0)
                        {
                        need_reboot = 1;
                        strcpy(config.ip,t5);
                        }
                    if (strcmp(config.gw,t6) != 0)
                        {
                        need_reboot = 1;
                        strcpy(config.gw,t6);
                        }
                    if (strcmp(config.netmask,t7) != 0)
                        {
                        need_reboot = 1;                        
                        strcpy(config.netmask,t7);
                        }
                    }
                //Station Name
                if (strcmp(config.name,t3) != 0)
                    strcpy(config.name,t3);
                //Station Password
                if (strcmp (t9, "current password") != 0)
                    strcpy(config.station_password,t9);
                //Use authorization for switches
                if (use_auth_temp)
                    strcpy(config.use_authorization,"yes");
                else
                    strcpy(config.use_authorization,"no");
                generate_response(CONFIG_SAVE);
                const char* resp_str = (const char*) user_str;
                httpd_resp_send(req, resp_str, strlen(resp_str));
                if (need_reboot)
                    {
                    config_write(PORT_OFF);
                    esp_restart();
                    }
                else
                    config_write(status);
                }
            else
                {
                if (!(strlen(t1) > 1 && strlen(t1) <= 32))
                    cfg_err = cfg_err | (1 << 1);
                if (strlen(t2) > 64)
                    cfg_err = cfg_err | (1 << 2);
                if (!(strlen(t3) > 1 && strlen(t3) <= 32))
                    cfg_err = cfg_err | (1 << 3);
                if (strcmp (t4, config.station_password) != 0)
                    cfg_err = cfg_err | (1 << 4);
                if ((isip_t5 == 0 || isip_t6 == 0 || isip_t7 == 0) && use_dhcp_temp == 0)
                    cfg_err = cfg_err | (1 << 5); 
                if (!(strlen(t9) > 1 && strlen(t9) <= 64))
                    cfg_err = cfg_err | (1 << 6);
                if (isip_t11 == 0)
                    cfg_err = cfg_err | (1 << 7); 
                generate_response(CONFIG_FAILED);
                const char* resp_str = (const char*) user_str;
                httpd_resp_send(req, resp_str, strlen(resp_str));
                }
            }
        else
            {
            generate_response(CONFIG_FAILED); 
            const char* resp_str = (const char*) user_str;          
            httpd_resp_send(req, resp_str, strlen(resp_str));
            }
        free(buf);
        }
    return ESP_OK;
}

/* An HTTP GET handler - PORTON */
esp_err_t switch_get_handler(httpd_req_t *req)
{
    char*  buf;
    size_t buf_len;  
    char param1[4],param2[4],param3[66],t1[4],t2[4],t3[66];
    buf_len = httpd_req_get_url_query_len(req) + 1;
    cfg_err = 0;
    //do port switch, if auth is needed check password
    if (buf_len > 1) 
        {
        buf = malloc(buf_len);
        if (httpd_req_get_url_query_str(req, buf, buf_len) == ESP_OK) 
            {
            if (httpd_query_key_value(buf, "station_password", param3, sizeof(param3)) == ESP_OK) 
                {
                strcpy(t3,url_decode(param3));
                ESP_LOGI(TAG, "Found URL query parameter => station_password");
                }
            if (httpd_query_key_value(buf, "timer_value", param2, sizeof(param2)) == ESP_OK) 
                {
                strcpy(t2,url_decode(param2));
                timer_min = atoi(t2);
                ESP_LOGI(TAG, "Found URL query parameter => timer_value=%i", timer_min);
                }
            if (httpd_query_key_value(buf, "new_state", param1, sizeof(param1)) == ESP_OK) 
                {
                strcpy(t1,url_decode(param1));
                ESP_LOGI(TAG, "Found URL query parameter => new_state=%s", t1);
                }
            }
        if (strcmp(config.use_authorization,"no") == 0)
            {
            if (strcmp(t1,"on") == 0)
                port_switch(PORT_ON);
            else if (strcmp(t1,"tim") == 0 && timer_min > 0)
                {
                if (timer_min > 960)
                    timer_min = 960;
                port_switch(PORT_TIMER);
                hw_timer_init(hw_timer_callback1, NULL);
                hw_timer_alarm_us(1000000, true);
                timer_sec = 0;
                }
            else if (strcmp(t1,"off") == 0)
                port_switch(PORT_OFF);
            }
            
        else if (strcmp(t3,config.station_password) == 0)
            {
            if (strcmp(t1,"on") == 0)
                port_switch(PORT_ON);
            else if (strcmp(t1,"tim") == 0 && timer_min > 0)
                {
                if (timer_min > 960)
                    timer_min = 960;
                port_switch(PORT_TIMER);
                hw_timer_init(hw_timer_callback1, NULL);
                hw_timer_alarm_us(1000000, true);
                timer_sec = 0;
                }
            else if (strcmp(t1,"off") == 0)
                port_switch(PORT_OFF);
            }
        }
    /* Send response with custom headers and body set as the
     * string passed in user context*/
    const char* resp_str = (const char*) user_str;
    //const char* resp_str = (const char*) req->user_ctx;
    httpd_resp_send(req, resp_str, strlen(resp_str));

    return ESP_OK;
}

/* An HTTP GET handler - ROOT */
esp_err_t root_get_handler(httpd_req_t *req)
{
    generate_response(status);
    /* Send response with custom headers and body set as the
     * string passed in user context*/
    const char* resp_str = (const char*) user_str;
    //const char* resp_str = (const char*) req->user_ctx;
    httpd_resp_send(req, resp_str, strlen(resp_str));

    return ESP_OK;
}

/* start the web server */
httpd_handle_t start_webserver(void)
{
    httpd_handle_t server = NULL;
    httpd_config_t config = HTTPD_DEFAULT_CONFIG();

    // Start the httpd server
    ESP_LOGI(TAG, "Starting server on port: '%d'", config.server_port);
    if (httpd_start(&server, &config) == ESP_OK) 
        {
        // Set URI handlers
        ESP_LOGI(TAG, "Registering URI handlers");
        httpd_register_uri_handler(server, &config_uri);
        httpd_register_uri_handler(server, &cfgsav_uri);
        httpd_register_uri_handler(server, &switch_uri);
        httpd_register_uri_handler(server, &root_uri);
        return server;
        }

    ESP_LOGI(TAG, "Error starting server!");
    return NULL;
}

/* stop webserver */
void stop_webserver(httpd_handle_t server)
{
    // Stop the httpd server
    httpd_stop(server);
}




